#pragma once

#include "randomizerTypes.h"
#include <array>
#include "variables.h"
#include <string>
#include <textures/icon_item_static/icon_item_static.h>
#include <textures/icon_item_24_static/icon_item_24_static.h>

std::array<Sprite, 100> gSeedTextures = { {
    { dgItemIconDekuNutTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 0 },
    { dgItemIconDekuStickTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 1 },
    { dgItemIconBombTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 2 },
    { dgItemIconBowTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 3 },
    { dgItemIconArrowFireTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 4 },
    { dgItemIconDinsFireTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 5 },
    { dgItemIconSlingshotTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 6 },
    { dgItemIconOcarinaFairyTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 7 },
    { dgItemIconOcarinaOfTimeTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 8 },
    { dgItemIconBombchuTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 9 },
    { dgItemIconHookshotTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 10 },
    { dgItemIconLongshotTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 11 },
    { dgItemIconArrowIceTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 12 },
    { dgItemIconFaroresWindTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 13 },
    { dgItemIconBoomerangTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 14 },
    { dgItemIconLensOfTruthTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 15 },
    { dgItemIconMagicBeanTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 16 },
    { dgItemIconHammerTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 17 },
    { dgItemIconArrowLightTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 18 },
    { dgItemIconNayrusLoveTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 19 },
    { dgItemIconBottleEmptyTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 20 },
    { dgItemIconBottlePotionRedTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 21 },
    { dgItemIconBottlePotionGreenTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 22 },
    { dgItemIconBottlePotionBlueTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 23 },
    { dgItemIconBottleFairyTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 24 },
    { dgItemIconBottleFishTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 25 },
    { dgItemIconBottleMilkFullTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 26 },
    { dgItemIconBottleRutosLetterTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 27 },
    { dgItemIconBottleBlueFireTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 28 },
    { dgItemIconBottleBugTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 29 },
    { dgItemIconBottleBigPoeTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 30 },
    { dgItemIconBottleMilkHalfTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 31 },
    { dgItemIconBottlePoeTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 32 },
    { dgItemIconZeldasLetterTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 33 },
    { dgItemIconMaskKeatonTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 34 },
    { dgItemIconMaskSkullTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 35 },
    { dgItemIconMaskSpookyTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 36 },
    { dgItemIconMaskBunnyHoodTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 37 },
    { dgItemIconMaskGoronTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 38 },
    { dgItemIconMaskZoraTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 39 },
    { dgItemIconMaskGerudoTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 40 },
    { dgItemIconMaskTruthTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 41 },
    { dgItemIconSoldOutTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 42 },
    { dgItemIconPocketEggTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 43 },
    { dgItemIconPocketCuccoTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 44 },
    { dgItemIconCojiroTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 45 },
    { dgItemIconOddMushroomTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 46 },
    { dgItemIconOddPotionTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 47 },
    { dgItemIconPoachersSawTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 48 },
    { dgItemIconBrokenGoronsSwordTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 49 },
    { dgItemIconPrescriptionTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 50 },
    { dgItemIconEyeballFrogTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 51 },
    { dgItemIconEyeDropsTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 52 },
    { dgItemIconClaimCheckTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 53 },
    { dgItemIconSwordKokiriTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 54 },
    { dgItemIconSwordMasterTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 55 },
    { dgItemIconSwordBiggoronTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 56 },
    { dgItemIconShieldDekuTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 57 },
    { dgItemIconShieldHylianTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 58 },
    { dgItemIconShieldMirrorTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 59 },
    { dgItemIconTunicKokiriTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 60 },
    { dgItemIconTunicGoronTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 61 },
    { dgItemIconTunicZoraTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 62 },
    { dgItemIconBootsKokiriTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 63 },
    { dgItemIconBootsIronTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 64 },
    { dgItemIconBootsHoverTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 65 },
    { dgItemIconBulletBag30Tex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 66 },
    { dgItemIconBulletBag40Tex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 67 },
    { dgItemIconBulletBag50Tex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 68 },
    { dgItemIconQuiver30Tex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 69 },
    { dgItemIconBombBag20Tex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 70 },
    { dgItemIconGoronsBraceletTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 71 },
    { dgItemIconSilverGauntletsTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 72 },
    { dgItemIconGoldenGauntletsTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 73 },
    { dgItemIconScaleSilverTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 74 },
    { dgItemIconScaleGoldenTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 75 },
    { dgItemIconBrokenGiantsKnifeTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 76 },
    { dgItemIconAdultsWalletTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 77 },
    { dgItemIconGiantsWalletTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 78 },
    { dgItemIconDekuSeedsTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 79 },
    { dgItemIconFishingPoleTex, 32, 32, G_IM_FMT_RGBA, G_IM_SIZ_32b, 80 },
    { dgQuestIconMedallionForestTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 81 },
    { dgQuestIconMedallionFireTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 82 },
    { dgQuestIconMedallionWaterTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 83 },
    { dgQuestIconMedallionSpiritTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 84 },
    { dgQuestIconMedallionShadowTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 85 },
    { dgQuestIconMedallionLightTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 86 },
    { dgQuestIconKokiriEmeraldTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 87 },
    { dgQuestIconGoronRubyTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 88 },
    { dgQuestIconZoraSapphireTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 89 },
    { dgQuestIconStoneOfAgonyTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 90 },
    { dgQuestIconGerudosCardTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 91 },
    { dgQuestIconGoldSkulltulaTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 92 },
    { dgQuestIconHeartContainerTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 93 },
    { dgQuestIconDungeonBossKeyTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 94 },
    { dgQuestIconDungeonCompassTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 95 },
    { dgQuestIconDungeonMapTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 96 },
    { dgQuestIconSmallKeyTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 97 },
    { dgQuestIconMagicJarSmallTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 98 },
    { dgQuestIconMagicJarBigTex, 24, 24, G_IM_FMT_RGBA, G_IM_SIZ_32b, 99 },
} };